pfUI.addonskinner:RegisterSkin("SuperMacro", function()
  
  local penv = pfUI:GetEnvironment()
  local StripTextures, CreateBackdrop, SkinButton, SkinCheckbox, SkinCloseButton, SkinTab, SkinScrollbar, EnableMovable, SetAllPointsOffset = 
  penv.StripTextures, penv.CreateBackdrop, penv.SkinButton, penv.SkinCheckbox, penv.SkinCloseButton, penv.SkinTab, penv.SkinScrollbar, penv.EnableMovable, penv.SetAllPointsOffset

  -- main frame
  StripTextures(SuperMacroFrame, true)
  CreateBackdrop(SuperMacroFrame, nil, nil, .75)
  SuperMacroFrame.backdrop:SetPoint("TOPLEFT", 10, -10)
  SuperMacroFrame.backdrop:SetPoint("BOTTOMRIGHT", -30, 72)
  SuperMacroFrame:SetHitRectInsets(10, 30, 10, 72)
  SkinCloseButton(SuperMacroFrameCloseButton, SuperMacroFrame.backdrop, -6, -6)
  SkinTab(SuperMacroFrameTab1)
  SkinTab(SuperMacroFrameTab2)
  SuperMacroFrameTab1:ClearAllPoints()
  SuperMacroFrameTab1:SetPoint("TOPLEFT", SuperMacroFrame.backdrop, "BOTTOMLEFT", 10, -3)
  SuperMacroFrameTab2:SetPoint("LEFT", SuperMacroFrameTab1, "RIGHT", 4, 0)
  CreateBackdrop(SuperMacroFrameTextBackground, .9)
  SetAllPointsOffset(SuperMacroFrameTextBackground.backdrop, SuperMacroFrameTextBackground, 2)
  StripTextures(SuperMacroFrameScrollFrame)
  SkinScrollbar(SuperMacroFrameScrollFrameScrollBar,true)
  CreateBackdrop(SuperMacroFrameExtendTextBackground, .9)
  SetAllPointsOffset(SuperMacroFrameExtendTextBackground.backdrop, SuperMacroFrameExtendTextBackground, 2)
  StripTextures(SuperMacroFrameExtendScrollFrame)
  SkinScrollbar(SuperMacroFrameExtendScrollFrameScrollBar,true)
  CreateBackdrop(SuperMacroFrameSuperTextBackground, .9)
  SetAllPointsOffset(SuperMacroFrameSuperTextBackground.backdrop, SuperMacroFrameSuperTextBackground, 2)
  StripTextures(SuperMacroFrameSuperEditScrollFrame)
  SkinScrollbar(SuperMacroFrameSuperEditScrollFrameScrollBar,true)
  SkinScrollbar(SuperMacroFrameSuperScrollFrameScrollBar)
  SkinButton(SuperMacroSaveButton)
  SkinButton(SuperMacroSaveExtendButton)
  SkinButton(SuperMacroNewAccountButton)
  SuperMacroNewAccountButton:SetPoint("TOPLEFT", 62, -37)
  SuperMacroFrameGeneralMacroText:SetPoint("CENTER", SuperMacroFrame, "TOPLEFT", 142, -66)
  SkinButton(SuperMacroNewCharacterButton)
  SkinButton(SuperMacroSaveSuperButton)
  SkinButton(SuperMacroNewSuperButton)
  SkinButton(SuperMacroEditButton)
  SkinButton(SuperMacroOptionsButton)
  SkinButton(SuperMacroExitButton)
  SkinButton(SuperMacroDeleteButton)
  SkinButton(SuperMacroDeleteExtendButton)
  SkinButton(SuperMacroDeleteSuperButton)
  for j=0, MAX_MACROS, MAX_MACROS do
    for i=1, MAX_MACROS do
      local offset = j+i
      local button = getglobal(string.format("SuperMacroButton%d",offset))
      local icon = getglobal(string.format("SuperMacroButton%dIcon",offset))
      StripTextures(button)
      SkinButton(button, nil, nil, nil, icon)
      button:SetCheckedTexture([[Interface\Buttons\CheckButtonHilight]])      
    end
  end
  for i=1, MACROS_SUPER_SHOWN do
    local button = getglobal(string.format("SuperMacroSuperButton%d",i))
    local icon = getglobal(string.format("SuperMacroSuperButton%dIcon",i))
    StripTextures(button)
    SkinButton(button, nil, nil, nil, icon)
    button:SetCheckedTexture([[Interface\Buttons\CheckButtonHilight]])    
  end
  StripTextures(SuperMacroFrameSelectedMacroButton)
  SkinButton(SuperMacroFrameSelectedMacroButton, nil, nil, nil, SuperMacroFrameSelectedMacroButtonIcon, true)
  StripTextures(SuperMacroFrameSelectedMacroSuperButton)
  SkinButton(SuperMacroFrameSelectedMacroSuperButton, nil, nil, nil, SuperMacroFrameSelectedMacroSuperButtonIcon, true)
  EnableMovable(SuperMacroFrame)
  -- popup
  StripTextures(SuperMacroPopupFrame)
  CreateBackdrop(SuperMacroPopupFrame, nil, nil, .75)
  SuperMacroPopupFrame:SetFrameStrata("DIALOG")
  SuperMacroPopupFrame:ClearAllPoints()
  SuperMacroPopupFrame:SetPoint("TOPLEFT", SuperMacroFrame.backdrop, "TOPRIGHT", 4, -2)
  StripTextures(SuperMacroPopupScrollFrame)
  SkinScrollbar(SuperMacroPopupScrollFrameScrollBar)
  SuperMacroPopupEditBox:DisableDrawLayer("BACKGROUND")
  CreateBackdrop(SuperMacroPopupEditBox, nil, true)
  SkinButton(SuperMacroPopupCancelButton)
  SuperMacroPopupCancelButton:SetPoint("BOTTOMRIGHT", SuperMacroPopupFrame.backdrop, -16, 6)
  SuperMacroPopupOkayButton:SetPoint("RIGHT", SuperMacroPopupCancelButton, "LEFT", -2, 0)
  SkinButton(SuperMacroPopupOkayButton)
  for i=1, NUM_MACRO_ICONS_SHOWN do
      local button = getglobal(string.format("SuperMacroPopupButton%d",i))
      local icon = getglobal(string.format("SuperMacroPopupButton%dIcon",i))
      StripTextures(button)
      SkinButton(button, nil, nil, nil, icon)
      button:SetCheckedTexture([[Interface\Buttons\CheckButtonHilight]])    
  end

  --Options
  StripTextures(SuperMacroOptionsFrame, true)
  CreateBackdrop(SuperMacroOptionsFrame, nil, nil, .75)
  SuperMacroOptionsFrame.backdrop:SetPoint("TOPLEFT", 12, -12)
  SuperMacroOptionsFrame.backdrop:SetPoint("BOTTOMRIGHT", -30, 72)
  SuperMacroOptionsFrame:SetHitRectInsets(12,30,12,72)
  SkinCloseButton(SuperMacroOptionsCloseButton, SuperMacroOptionsFrame.backdrop, -6, -6)
  SkinCheckbox(SuperMacroOptionsFrameCheckButton1,25)
  SkinCheckbox(SuperMacroOptionsFrameCheckButton2,25)
  SkinCheckbox(SuperMacroOptionsFrameCheckButton3,25)
  SkinCheckbox(SuperMacroOptionsFrameCheckButton4,25)
  SkinCheckbox(SuperMacroOptionsFrameCheckButton5,25)
  SkinCheckbox(SuperMacroOptionsFrameCheckButton6,25)
  SkinCheckbox(SuperMacroOptionsFrameCheckButton7,25)
  SkinCheckbox(SuperMacroOptionsFrameCheckButton8,25)
  local bg = SuperMacroOptionsFrame:CreateTexture(nil, "BACKGROUND")
  bg:SetPoint("TOPLEFT", 40, -60)
  bg:SetPoint("BOTTOMRIGHT", -60, 112)
  bg:SetTexCoord(.1,1,0,1)
  bg:SetTexture("Interface\\Stationery\\StationeryTest1")  
  SkinButton(SuperMacroOptionsExitButton)
  EnableMovable(SuperMacroOptionsFrame)

  --GameMenu
  SkinButton(GameMenuButtonSuperMacro)
  GameMenuButtonSuperMacro:ClearAllPoints()
  GameMenuButtonSuperMacro:SetPoint("LEFT", GameMenuButtonOptions, "RIGHT",11,-46)
  
  pfUI.addonskinner:UnregisterSkin("SuperMacro")
end)

